"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectTimezone = exports.makeVirtualMenuListComponent = exports.getTimezoneProps = void 0;
var react_1 = require("react");
var react_select_1 = require("react-select");
var lodash_sortby_1 = require("lodash.sortby");
var moment_timezone_1 = require("moment-timezone");
var react_virtualized_1 = require("react-virtualized");
var formatTimezone_1 = require("./formatTimezone");
__exportStar(require("./formatTimezone"), exports);
var getTimezoneProps = function (tzString) {
    var tz = moment_timezone_1.default.tz(tzString);
    var tzStringOffset = tz.format('Z').replace(':00', '').replace(':30', '.5');
    var x = tzStringOffset === 0 ? 0 : parseInt(tzStringOffset).toFixed(2);
    return {
        label: formatTimezone_1.formatTimezone(tzString),
        value: "" + tzString,
        time: "" + x,
        offset: tz._offset,
    };
};
exports.getTimezoneProps = getTimezoneProps;
var makeVirtualMenuListComponent = function (ListProps) {
    return function (props) {
        return (react_1.default.createElement(react_virtualized_1.List, __assign({ rowCount: props.children.length, style: {
                width: '100%',
            }, rowHeight: 34.18, height: 300, width: 600, rowRenderer: function (_a) {
                var key = _a.key, index = _a.index, style = _a.style;
                return (react_1.default.createElement("div", { style: style, key: key }, props.children[index]));
            } }, ListProps)));
    };
};
exports.makeVirtualMenuListComponent = makeVirtualMenuListComponent;
var SelectTimezone = /** @class */ (function (_super) {
    __extends(SelectTimezone, _super);
    function SelectTimezone(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {};
        var timeZones = moment_timezone_1.default.tz.names().map(function (tz) {
            return exports.getTimezoneProps(tz);
        });
        _this.timeZones = lodash_sortby_1.default(timeZones, [
            function (el) {
                return -el.time;
            },
        ]);
        return _this;
    }
    SelectTimezone.prototype.componentDidMount = function () {
        var _a = this.props, onChange = _a.onChange, value = _a.value;
        if (this.props.guess && !value) {
            var guessed = moment_timezone_1.default.tz.guess();
            onChange && onChange(guessed);
            this.setState({
                selectedValue: guessed,
            });
        }
    };
    SelectTimezone.getDerivedStateFromProps = function (nextProps, prevState) {
        if (nextProps.value === undefined) {
            return null;
        }
        if (nextProps.value != prevState.selectedValue) {
            return {
                selectedValue: nextProps.value,
            };
        }
        return null;
    };
    SelectTimezone.prototype.render = function () {
        var _this = this;
        var _a = this.props, onChange = _a.onChange, selectedTimezoneValue = _a.value, _b = _a.isClearable, isClearable = _b === void 0 ? false : _b, className = _a.className, restProps = __rest(_a, ["onChange", "value", "isClearable", "className"]);
        var selectClassName = className ? className : 'react-select-timezone';
        var selected = this.timeZones.find(function (_a) {
            var value = _a.value;
            return value === _this.state.selectedValue;
        });
        return (react_1.default.createElement(react_select_1.default, __assign({ className: selectClassName, isClearable: isClearable, options: this.timeZones, isMulti: false, onChange: function (option) {
                if (option) {
                    _this.setState({ selectedValue: option.value });
                    onChange && onChange(option.value);
                }
                else {
                    _this.setState({ selectedValue: null });
                    onChange && onChange(null);
                }
            }, value: selected }, restProps)));
    };
    return SelectTimezone;
}(react_1.default.Component));
exports.SelectTimezone = SelectTimezone;
